diff --git a/game/client/src/main/java/net/minecraft/client/gui/Gui.java b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
index 765af2463..a32fcd029 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
@@ -1,32 +1,29 @@
 package net.minecraft.client.gui;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texture.meta.gui.GuiTextureProperties;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 import java.util.Objects;
 
-public class Gui
-{
-
-    public Gui()
-    {
+public class Gui {
+    public float zLevel;
+    public Gui() {
         this.zLevel = 0.0F;
     }
 
-    public void drawLineHorizontal(int minX, int maxX, final int minY, final int argb)
-    {
-        if(maxX < minX)
-        {
+    public void drawLineHorizontal(int minX, int maxX, final int minY, final int argb) {
+        if (maxX < minX) {
             final int temp = minX;
             minX = maxX;
             maxX = temp;
@@ -34,10 +31,8 @@ public class Gui
         drawRect(minX, minY, maxX + 1, minY + 1, argb);
     }
 
-    public void drawLineHorizontalDouble(double minX, double maxX, final double minY, final int argb)
-    {
-        if(maxX < minX)
-        {
+    public void drawLineHorizontalDouble(double minX, double maxX, final double minY, final int argb) {
+        if (maxX < minX) {
             final double temp = minX;
             minX = maxX;
             maxX = temp;
@@ -45,10 +40,8 @@ public class Gui
         drawRectDouble(minX, minY, maxX + 1, minY + 1, argb);
     }
 
-    public void drawLineVertical(final int minX, int minY, int maxY, final int argb)
-    {
-        if(maxY < minY)
-        {
+    public void drawLineVertical(final int minX, int minY, int maxY, final int argb) {
+        if (maxY < minY) {
             final int temp = minY;
             minY = maxY;
             maxY = temp;
@@ -56,10 +49,8 @@ public class Gui
         drawRect(minX, minY + 1, minX + 1, maxY, argb);
     }
 
-    public void drawLineVerticalDouble(final double minX, double minY, double maxY, final int argb)
-    {
-        if(maxY < minY)
-        {
+    public void drawLineVerticalDouble(final double minX, double minY, double maxY, final int argb) {
+        if (maxY < minY) {
             final double temp = minY;
             minY = maxY;
             maxY = temp;
@@ -67,69 +58,57 @@ public class Gui
         drawRectDouble(minX, minY + 1, minX + 1, maxY, argb);
     }
 
-    public void drawRect(int minX, int minY, int maxX, int maxY, final int argb)
-    {
-        if(minX < maxX)
-        {
+    public void drawRect(int minX, int minY, int maxX, int maxY, final int argb) {
+        if (minX < maxX) {
             final int temp = minX;
             minX = maxX;
             maxX = temp;
         }
-        if(minY < maxY)
-        {
+        if (minY < maxY) {
             final int temp = minY;
             minY = maxY;
             maxY = temp;
         }
-        final float a = (float)(argb >> 24 & 0xff) / 255F;
-        final float r = (float)(argb >> 16 & 0xff) / 255F;
-        final float g = (float)(argb >> 8 & 0xff) / 255F;
-        final float b = (float)(argb & 0xff) / 255F;
-        final Tessellator tessellator = Tessellator.instance;
-        GL11.glEnable(GL_BLEND);
-        GL11.glDisable(GL_TEXTURE_2D);
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glColor4f(r, g, b, a);
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.setColor1i(argb);
         tessellator.startDrawingQuads();
         tessellator.addVertex(minX, maxY, this.zLevel);
         tessellator.addVertex(maxX, maxY, this.zLevel);
         tessellator.addVertex(maxX, minY, this.zLevel);
         tessellator.addVertex(minX, minY, this.zLevel);
         tessellator.draw();
-        GL11.glEnable(GL_TEXTURE_2D);
-        GL11.glDisable(GL_BLEND);
+        GLRenderer.popFrame();
     }
-    public void drawRectDouble(double minX, double minY, double maxX, double maxY, final int argb)
-    {
-        if(minX < maxX)
-        {
+
+    public void drawRectDouble(double minX, double minY, double maxX, double maxY, final int argb) {
+        if (minX < maxX) {
             final double temp = minX;
             minX = maxX;
             maxX = temp;
         }
-        if(minY < maxY)
-        {
+        if (minY < maxY) {
             final double temp = minY;
             minY = maxY;
             maxY = temp;
         }
-        final float a = (float)(argb >> 24 & 0xff) / 255F;
-        final float r = (float)(argb >> 16 & 0xff) / 255F;
-        final float g = (float)(argb >> 8 & 0xff) / 255F;
-        final float b = (float)(argb & 0xff) / 255F;
-        final Tessellator tessellator = Tessellator.instance;
-        GL11.glEnable(GL_BLEND);
-        GL11.glDisable(GL_TEXTURE_2D);
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glColor4f(r, g, b, a);
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.setColor1i(argb);
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.addVertex(minX, maxY, this.zLevel);
         tessellator.addVertex(maxX, maxY, this.zLevel);
         tessellator.addVertex(maxX, minY, this.zLevel);
         tessellator.addVertex(minX, minY, this.zLevel);
         tessellator.draw();
-        GL11.glEnable(GL_TEXTURE_2D);
-        GL11.glDisable(GL_BLEND);
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.popFrame();
     }
 
     public void drawBox(final int minX, final int minY, final int maxX, final int maxY, final int argb, final int lineThickness) {
@@ -139,108 +118,98 @@ public class Gui
         drawRect(maxX - lineThickness, minY + lineThickness, maxX, maxY - lineThickness, argb);
     }
 
-    public void drawRectNoBlend(int minX, int minY, int maxX, int maxY, final int argb)
-    {
-        if(minX < maxX)
-        {
+    public void drawRectNoBlend(int minX, int minY, int maxX, int maxY, final int argb) {
+        if (minX < maxX) {
             final int temp = minX;
             minX = maxX;
             maxX = temp;
         }
-        if(minY < maxY)
-        {
+        if (minY < maxY) {
             final int temp = minY;
             minY = maxY;
             maxY = temp;
         }
-        final float a = (float)(argb >> 24 & 0xff) / 255F;
-        final float r = (float)(argb >> 16 & 0xff) / 255F;
-        final float g = (float)(argb >> 8 & 0xff) / 255F;
-        final float b = (float)(argb & 0xff) / 255F;
-        final Tessellator tessellator = Tessellator.instance;
-        GL11.glDisable(GL_TEXTURE_2D);
-        GL11.glColor4f(r, g, b, a);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.setColor1i(argb);
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.addVertex(minX, maxY, 0.0D);
         tessellator.addVertex(maxX, maxY, 0.0D);
         tessellator.addVertex(maxX, minY, 0.0D);
         tessellator.addVertex(minX, minY, 0.0D);
         tessellator.draw();
-        GL11.glEnable(GL_TEXTURE_2D);
+        GLRenderer.popFrame();
     }
-    
+
     public void drawRectWidthHeight(final int x, final int y, final int width, final int height, final int argb) {
-    	final float a = ((argb >> 24) & 0xFF) / 255f;
-    	final float r = ((argb >> 16) & 0xFF) / 255f;
-    	final float g = ((argb >>  8) & 0xFF) / 255f;
-    	final float b = ((argb >>  0) & 0xFF) / 255f;
-    	glColor4f(r, g, b, a);
-    	glDisable(GL_TEXTURE_2D);
-        final Tessellator tessellator = Tessellator.instance;
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.setColor1i(argb);
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.addVertex(x, y, 0);
-        tessellator.addVertex(x, y+height, 0);
-        tessellator.addVertex(x+width, y+height, 0);
-        tessellator.addVertex(x+width, y, 0);
+        tessellator.addVertex(x, y + height, 0);
+        tessellator.addVertex(x + width, y + height, 0);
+        tessellator.addVertex(x + width, y, 0);
         tessellator.draw();
-        glEnable(GL_TEXTURE_2D);
-    }
-
-    public void drawGradientRect(final int minX, final int minY, final int maxX, final int maxY, final int argb1, final int argb2)
-    {
-        final float a1 = (float)(argb1 >> 24 & 0xff) / 255F;
-        final float r1 = (float)(argb1 >> 16 & 0xff) / 255F;
-        final float g1 = (float)(argb1 >> 8 & 0xff) / 255F;
-        final float b1 = (float)(argb1 & 0xff) / 255F;
-        final float a2 = (float)(argb2 >> 24 & 0xff) / 255F;
-        final float r2 = (float)(argb2 >> 16 & 0xff) / 255F;
-        final float g2 = (float)(argb2 >> 8 & 0xff) / 255F;
-        final float b2 = (float)(argb2 & 0xff) / 255F;
-        GL11.glDisable(GL_TEXTURE_2D);
-        GL11.glEnable(GL_BLEND);
-        GL11.glDisable(GL_ALPHA_TEST);
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glShadeModel(GL_SMOOTH);
-        final Tessellator tessellator = Tessellator.instance;
+        GLRenderer.popFrame();
+    }
+
+    public void drawGradientRect(final int minX, final int minY, final int maxX, final int maxY, final int argb1, final int argb2) {
+        final float a1 = (float) (argb1 >> 24 & 0xff) / 255F;
+        final float r1 = (float) (argb1 >> 16 & 0xff) / 255F;
+        final float g1 = (float) (argb1 >> 8 & 0xff) / 255F;
+        final float b1 = (float) (argb1 & 0xff) / 255F;
+        final float a2 = (float) (argb2 >> 24 & 0xff) / 255F;
+        final float r2 = (float) (argb2 >> 16 & 0xff) / 255F;
+        final float g2 = (float) (argb2 >> 8 & 0xff) / 255F;
+        final float b2 = (float) (argb2 & 0xff) / 255F;
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.enableState(State.BLEND);
+//        GL11.glDisable(GL_ALPHA_TEST);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+//        GL11.glShadeModel(GL_SMOOTH);
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_F(r1, g1, b1, a1);
+        tessellator.setColor4f(r1, g1, b1, a1);
         tessellator.addVertex(maxX, minY, 0.0D);
         tessellator.addVertex(minX, minY, 0.0D);
-        tessellator.setColorRGBA_F(r2, g2, b2, a2);
+        tessellator.setColor4f(r2, g2, b2, a2);
         tessellator.addVertex(minX, maxY, 0.0D);
         tessellator.addVertex(maxX, maxY, 0.0D);
         tessellator.draw();
-        GL11.glShadeModel(GL_FLAT);
-        GL11.glDisable(GL_BLEND);
-        GL11.glEnable(GL_ALPHA_TEST);
-        GL11.glEnable(GL_TEXTURE_2D);
+//        GL11.glShadeModel(GL_FLAT);
+        GLRenderer.disableState(State.BLEND);
+//        GL11.glEnable(GL_ALPHA_TEST);
+        GLRenderer.popFrame();
     }
 
     public void drawStringCenteredShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
-        fontRenderer.renderCentered(Tessellator.instance, chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call();
+        fontRenderer.renderCentered(chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call();
     }
 
     public void drawStringCenteredNoShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
-        fontRenderer.renderCentered(Tessellator.instance, chars, x, y).setZ(this.zLevel).setColor(argb).call();
+        fontRenderer.renderCentered(chars, x, y).setZ(this.zLevel).setColor(argb).call();
     }
 
     public void drawStringShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
-        fontRenderer.render(Tessellator.instance, chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call();
+        fontRenderer.render(chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call();
     }
-    
+
     public void drawStringNoShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
-        fontRenderer.render(Tessellator.instance, chars, x, y).setZ(this.zLevel).setColor(argb).call();
+        fontRenderer.render(chars, x, y).setZ(this.zLevel).setColor(argb).call();
     }
 
     public void drawStringConstrained(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int maxWidth, final int argb) {
-        fontRenderer.renderWidthConstrained(Tessellator.instance, chars, x, y, maxWidth).setZ(this.zLevel).setColor(argb).call();
+        fontRenderer.renderWidthConstrained(chars, x, y, maxWidth).setZ(this.zLevel).setColor(argb).call();
     }
 
-    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height)
-    {
+    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height) {
         final float uScale = 0.00390625F;
         final float vScale = 0.00390625F;
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(x, y + height, this.zLevel, (u) * uScale, (v + height) * vScale);
         tessellator.addVertexWithUV(x + width, y + height, this.zLevel, (u + width) * uScale, (v + height) * vScale);
@@ -248,73 +217,69 @@ public class Gui
         tessellator.addVertexWithUV(x, y, this.zLevel, (u) * uScale, (v) * vScale);
         tessellator.draw();
     }
-    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height, final double uScale, final double vScale)
-    {
+
+    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height, final double uScale, final double vScale) {
         final double off = 0.05d;
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x - off,        y + height + off, this.zLevel, (u) * uScale,        (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y + height + off, this.zLevel, (u + width) * uScale,    (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y - off, this.zLevel, (u + width) * uScale,    (v) * vScale);
-        tessellator.addVertexWithUV(x - off,        y - off, this.zLevel, (u) * uScale,        (v) * vScale);
+        tessellator.addVertexWithUV(x - off, y + height + off, this.zLevel, (u) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off, y + height + off, this.zLevel, (u + width) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off, y - off, this.zLevel, (u + width) * uScale, (v) * vScale);
+        tessellator.addVertexWithUV(x - off, y - off, this.zLevel, (u) * uScale, (v) * vScale);
         tessellator.draw();
     }
-    public void drawTexturedModalRectDouble(final double x, final double y, final double u, final double v, final double width, final double height, final double uScale, final double vScale)
-    {
+
+    public void drawTexturedModalRectDouble(final double x, final double y, final double u, final double v, final double width, final double height, final double uScale, final double vScale) {
         final double off = 0.05d;
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x - off,        y + height + off, this.zLevel, (u + 0) * uScale,        (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y + height + off, this.zLevel, (u + width) * uScale,    (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y - off, this.zLevel, (u + width) * uScale,    (v + 0) * vScale);
-        tessellator.addVertexWithUV(x - off,        y - off, this.zLevel, (u + 0) * uScale,        (v + 0) * vScale);
+        tessellator.addVertexWithUV(x - off, y + height + off, this.zLevel, (u + 0) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off, y + height + off, this.zLevel, (u + width) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off, y - off, this.zLevel, (u + width) * uScale, (v + 0) * vScale);
+        tessellator.addVertexWithUV(x - off, y - off, this.zLevel, (u + 0) * uScale, (v + 0) * vScale);
         tessellator.draw();
     }
 
-    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height, final double uScale, final double vScale, final double off)
-    {
-        final Tessellator tessellator = Tessellator.instance;
+    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height, final double uScale, final double vScale, final double off) {
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x - off,        y + height + off, this.zLevel, (u) * uScale,        (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y + height + off, this.zLevel, (u + width) * uScale,    (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y - off, this.zLevel, (u + width) * uScale,    (v) * vScale);
-        tessellator.addVertexWithUV(x - off,        y - off, this.zLevel, (u) * uScale,        (v) * vScale);
+        tessellator.addVertexWithUV(x - off, y + height + off, this.zLevel, (u) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off, y + height + off, this.zLevel, (u + width) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off, y - off, this.zLevel, (u + width) * uScale, (v) * vScale);
+        tessellator.addVertexWithUV(x - off, y - off, this.zLevel, (u) * uScale, (v) * vScale);
         tessellator.draw();
     }
 
-    public void drawTexturedModalRectDouble(final double x, final double y, final double u, final double v, final double width, final double height, final double uScale, final double vScale, final double off)
-    {
+    public void drawTexturedModalRectDouble(final double x, final double y, final double u, final double v, final double width, final double height, final double uScale, final double vScale, final double off) {
         final double foon = /*(0.25d * uScale)*/0;
         final double goon = /*(0.25d * vScale)*/0;
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x - off,        y + height + off, this.zLevel, (u + 0.5) * uScale,       (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y + height + off, this.zLevel, (u + width - 0.5) * uScale,   (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y - off, this.zLevel, (u + width - 0.5) * uScale,    v * vScale);
-        tessellator.addVertexWithUV(x - off,        y - off, this.zLevel, (u + 0.5) * uScale,        v * vScale);
+        tessellator.addVertexWithUV(x - off, y + height + off, this.zLevel, (u + 0.5) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off, y + height + off, this.zLevel, (u + width - 0.5) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off, y - off, this.zLevel, (u + width - 0.5) * uScale, v * vScale);
+        tessellator.addVertexWithUV(x - off, y - off, this.zLevel, (u + 0.5) * uScale, v * vScale);
         tessellator.draw();
     }
 
 
-    public void drawTexturedModalRectDouble(final double x, final double y, final double u, final double v, final double width, final double height, final double uWidth, final double vHeight, final double uScale, final double vScale)
-    {
+    public void drawTexturedModalRectDouble(final double x, final double y, final double u, final double v, final double width, final double height, final double uWidth, final double vHeight, final double uScale, final double vScale) {
         final double foon = (0.5f * uScale);
         final double goon = 0.0625f * (16.0f / uWidth);
         final double off = 0.05d;
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x - off,        y + height + off, this.zLevel, (u + foon) * uScale,             (v + vHeight - foon) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y + height + off, this.zLevel, (u + uWidth - foon) * uScale,    (v + vHeight - foon) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y - off, this.zLevel, (u + uWidth - foon) * uScale,    (v + foon) * vScale);
-        tessellator.addVertexWithUV(x - off,        y - off, this.zLevel, (u + foon) * uScale,             (v + foon) * vScale);
+        tessellator.addVertexWithUV(x - off, y + height + off, this.zLevel, (u + foon) * uScale, (v + vHeight - foon) * vScale);
+        tessellator.addVertexWithUV(x + width + off, y + height + off, this.zLevel, (u + uWidth - foon) * uScale, (v + vHeight - foon) * vScale);
+        tessellator.addVertexWithUV(x + width + off, y - off, this.zLevel, (u + uWidth - foon) * uScale, (v + foon) * vScale);
+        tessellator.addVertexWithUV(x - off, y - off, this.zLevel, (u + foon) * uScale, (v + foon) * vScale);
         tessellator.draw();
     }
 
-    public void drawTexturedModalRect(final double x, final double y, final int u, final int v, final int width, final int height, final int uvWidth, final int uvHeight)
-    {
+    public void drawTexturedModalRect(final double x, final double y, final int u, final int v, final int width, final int height, final int uvWidth, final int uvHeight) {
         final float uScale = 0.00390625F;
         final float vScale = 0.00390625F;
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(x + 0, y + height, this.zLevel, (u) * uScale, (v + uvHeight) * vScale);
         tessellator.addVertexWithUV(x + width, y + height, this.zLevel, (u + uvWidth) * uScale, (v + uvHeight) * vScale);
@@ -322,12 +287,11 @@ public class Gui
         tessellator.addVertexWithUV(x + 0, y + 0, this.zLevel, (u) * uScale, (v) * vScale);
         tessellator.draw();
     }
-    
-    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height, final int uvWidth, final float scale)
-    {
+
+    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height, final int uvWidth, final float scale) {
         final float uScale = scale;
         final float vScale = scale;
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(x, y + height, this.zLevel, (u) * uScale, (v + uvWidth) * vScale);
         tessellator.addVertexWithUV(x + width, y + height, this.zLevel, (u + uvWidth) * uScale, (v + uvWidth) * vScale);
@@ -335,13 +299,13 @@ public class Gui
         tessellator.addVertexWithUV(x, y, this.zLevel, (u) * uScale, (v) * vScale);
         tessellator.draw();
     }
-    public void drawTexturedIcon(final int x, final int y, final int width, final int height, final IconCoordinate coordinate)
-    {
+
+    public void drawTexturedIcon(final int x, final int y, final int width, final int height, final IconCoordinate coordinate) {
         coordinate.parentAtlas.bind();
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x,      y + height, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
-        tessellator.addVertexWithUV(x + width,  y + height, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
+        tessellator.addVertexWithUV(x, y + height, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
+        tessellator.addVertexWithUV(x + width, y + height, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
         tessellator.addVertexWithUV(x + width, y, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMin());
         tessellator.addVertexWithUV(x, y, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMin());
         tessellator.draw();
@@ -351,7 +315,7 @@ public class Gui
         final Texture tex = re.loadTexture(texture);
         tex.bind();
 
-        final Tessellator t = Tessellator.instance;
+        final TessellatorGeneral t = GLRenderer.getTessellator();
         if (tex.hasMeta("gui")) {
             final GuiTextureProperties properties = Objects.requireNonNull(tex.getMeta("gui", GuiTextureProperties.class));
             switch (properties.type) {
@@ -365,13 +329,13 @@ public class Gui
                     break;
                 }
                 case GuiTextureProperties.TYPE_TILE: {
-                    final double uScale = 1d/ properties.width;
-                    final double vScale = 1d/ properties.height;
+                    final double uScale = 1d / properties.width;
+                    final double vScale = 1d / properties.height;
                     t.startDrawingQuads();
-                    t.addVertexWithUV(x        , y + height, this.zLevel, 0,              height * vScale);
+                    t.addVertexWithUV(x, y + height, this.zLevel, 0, height * vScale);
                     t.addVertexWithUV(x + width, y + height, this.zLevel, width * uScale, height * vScale);
-                    t.addVertexWithUV(x + width, y         , this.zLevel, width * uScale, 0);
-                    t.addVertexWithUV(x        , y         , this.zLevel, 0,              0);
+                    t.addVertexWithUV(x + width, y, this.zLevel, width * uScale, 0);
+                    t.addVertexWithUV(x, y, this.zLevel, 0, 0);
                     t.draw();
                     break;
                 }
@@ -515,10 +479,10 @@ public class Gui
             }
         } else {
             t.startDrawingQuads();
-            t.addVertexWithUV(x        , y + height, this.zLevel, 0, 1);
+            t.addVertexWithUV(x, y + height, this.zLevel, 0, 1);
             t.addVertexWithUV(x + width, y + height, this.zLevel, 1, 1);
-            t.addVertexWithUV(x + width, y         , this.zLevel, 1, 0);
-            t.addVertexWithUV(x        , y         , this.zLevel, 0, 0);
+            t.addVertexWithUV(x + width, y, this.zLevel, 1, 0);
+            t.addVertexWithUV(x, y, this.zLevel, 0, 0);
             t.draw();
         }
     }
@@ -526,19 +490,18 @@ public class Gui
     public void drawGuiIcon(final int x, final int y, final int width, final int height, final @NotNull IconCoordinate coordinate) {
         drawGuiIconDouble(x, y, width, height, coordinate);
     }
-    public void drawGuiIconDouble(final double x, final double y, final double width, final double height, final @NotNull IconCoordinate coordinate) {
-        coordinate.parentAtlas.bind();
-        final Tessellator t = Tessellator.instance;
+
+    public void addGuiIconDouble(@NotNull TessellatorGeneral t, final double x, final double y, final double width, final double height, final @NotNull IconCoordinate coordinate) {
+        final double epW = 0.25 * coordinate.parentAtlas.getInverseWidth();
+        final double epH = 0.25 * coordinate.parentAtlas.getInverseHeight();
         if (coordinate.hasMeta("gui")) {
             final GuiTextureProperties properties = Objects.requireNonNull(coordinate.getMeta("gui", GuiTextureProperties.class));
             switch (properties.type) {
                 case GuiTextureProperties.TYPE_STRETCH: {
-                    t.startDrawingQuads();
-                    t.addVertexWithUV(x,            y + height, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
-                    t.addVertexWithUV(x + width,    y + height, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
-                    t.addVertexWithUV(x + width,    y, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMin());
-                    t.addVertexWithUV(x,            y, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMin());
-                    t.draw();
+                    t.addVertexWithUV(x, y + height, this.zLevel, coordinate.getIconUMin() + epW, coordinate.getIconVMax() - epH);
+                    t.addVertexWithUV(x + width, y + height, this.zLevel, coordinate.getIconUMax() - epW, coordinate.getIconVMax() - epH);
+                    t.addVertexWithUV(x + width, y, this.zLevel, coordinate.getIconUMax() - epW, coordinate.getIconVMin() + epH);
+                    t.addVertexWithUV(x, y, this.zLevel, coordinate.getIconUMin() + epW, coordinate.getIconVMin() + epH);
                     break;
                 }
                 case GuiTextureProperties.TYPE_TILE: {
